import { defineStore } from 'pinia'
import { ref } from 'vue'
import axios from '@nextcloud/axios'
import { generateUrl } from '@nextcloud/router'

export const useNavStore = defineStore('nav', () => {
  const categories = ref(null)
  const apps = ref(null)

  async function getApps() {
    if (apps.value !== null) {
      return apps.value
    }

    apps.value = []
    const cats = await getCategories()

    cats.forEach((category) => {
      Object.values(category.apps).forEach((app) => {
        apps.value.push(app)
      })
    })

    return apps.value
  }

  async function getCategories() {
    if (categories.value !== null) {
      return categories.value
    }

    categories.value = await axios.get(generateUrl('/apps/side_menu/nav/items')).then((response) => response.data.items)

    return categories.value
  }

  return {
    getApps,
    getCategories,
  }
})
